// ASPI.h : definition file
//
#define ASPI_EXECP(SRB)		((SRB_MyExecSCSICmd *)SRB)
#define ASPI_RESETP(SRB)	((SRB_BusDeviceReset *)SRB)

#define ASPICMD_LOAD	1
#define ASPICMD_UNLOAD	0

enum ASPIERRORS {	ASPIERR_OK=0,
					ASPIERR_PENDING,		//SRB being processed
					ASPIERR_ABORTED,		//SRB aborted
					ASPIERR_ABORTFAILED,	//abort failed
					ASPIERR_ERR,			//SRB completed without error
					ASPIERR_SELTIMEOUT,		//Selection Timeout
					ASPIERR_OVERUNDER,		//Data overrun data underrun
					ASPIERR_BUSFREE,		//Unexpected bus free
					ASPIERR_PHASE,			//Target bus phase sequence
					ASPIERR_TIMEOUT,		//Timed out while SRB was
					ASPIERR_CMDTIMEOUT,		//While processing the SRB, the
					ASPIERR_REJECT,			//While processing SRB, the
					ASPIERR_RESET,			//A bus reset was detected.
					ASPIERR_PARITY,			//A parity error was detected.
					ASPIERR_SENSE,			//The adapter failed in issuing
					ASPIERR_CHKCOND,		//Device Check Condition
					ASPIERR_RECOVERED,		//Recovered Error
					ASPIERR_NOTREADY,		//Device not ready
					ASPIERR_MEDIUMERR,		//Medium Error
					ASPIERR_HARDERR,		//Hardware Error
					ASPIERR_ILLEGAL,		//Illegal Request
					ASPIERR_UNITATT,		//Unit Attention
					ASPIERR_PROTECTED,		//Data Protect
					ASPIERR_BLANKCHK,		//Blank Check
					ASPIERR_VENDOR,			//Vendor Specific
					ASPIERR_COPYABORT,		//Copy Abort
					ASPIERR_EQUAL,			//Equal (Search)
					ASPIERR_TAPEFULL,		//Volume Overflow
					ASPIERR_MISCOMP,		//Miscompare (Search)
					ASPIERR_RESERVED,		//Reserved
					ASPIERR_COMDMET,		//Device Condition Met
					ASPIERR_BUSY,			//Device Busy
					ASPIERR_INTERM,			//Device Intermediate
					ASPIERR_INTCDMET,		//Device Intermediate-condition met
					ASPIERR_RESCONF,		//Device Reservation conflict
					ASPIERR_COMTERM,		//Device Command Terminated
					ASPIERR_QFULL,			//Device Queue full
					ASPIERR_UNKNOWN,		//UNKNOWN
					ASPIERR_COMMAND,		//Invalid ASPI command
					ASPIERR_HA,				//Invalid host adapter number
					ASPIERR_NODEVICE,		//SCSI device not installed
					ASPIERR_SRB,			//Invalid parameter set in SRB
					ASPIERR_ALIGN,			//Buffer alignment problem
					ASPIERR_SECURE,			//Device access security violation
					ASPIERR_INIT,			//ASPI for windows failed init
					ASPIERR_SIZE,			//Buffer size too big to handle
					ASPIERR_FILEMRK,		//Filemark detected
					ASPIERR_EOM,			//End Of Medium detected
					ASPIERR_ILI,			//ILI ??? detected
					ASPIERR_SETMRK=52,		//52
					ASPIERR_BOM,			//53
					ASPIERR_EOD,			//54
					ASPIERR_IOTERM,			//55
					ASPIERR_PWRTFLT,		//56
					ASPIERR_NOWRITE,		//57
					ASPIERR_EWRTERR,		//58
					ASPIERR_LUNNRDNC,		//59
					ASPIERR_LUNBRD,			//60
					ASPIERR_LUNNRDIR,		//
					ASPIERR_LUNNRDMI,		//
					ASPIERR_LUNNRDFP,		//
					ASPIERR_LUNNSEL,		//
					ASPIERR_MULTSEL,		//
					ASPIERR_LUNCFAIL,		//
					ASPIERR_LUNCTIME,		//
					ASPIERR_LUNCPAR,		//
					ASPIERR_TRKFOLOW,		//
					ASPIERR_LOGOVER,		//70
					ASPIERR_WRITE,			//
					ASPIERR_URREAD,			//
					ASPIERR_RDRETRY,		//
					ASPIERR_TOOLONG,		//
					ASPIERR_MULREAD,		//
					ASPIERR_IBLKRD,			//
					ASPIERR_NOGAP,			//
					ASPIERR_MISCORR,		//
					ASPIERR_RECENTI,		//
					ASPIERR_RECORD,			//80
					ASPIERR_FILSET,			//
					ASPIERR_NOEOD,			//
					ASPIERR_BLKSEQ,			//
					ASPIERR_RNDPOS,			//
					ASPIERR_MECHPOS,		//
					ASPIERR_RDPOSE,			//
					ASPIERR_RECDNEC,		//
                    ASPIERR_RECDRET,		//
                    ASPIERR_RECDPHO,		//
                    ASPIERR_RECDNHO,		//90
                    ASPIERR_RECDWEC,		//
                    ASPIERR_PARLLEN,		//
                    ASPIERR_SYNCERR,		//
                    ASPIERR_INVCOC,			//
                    ASPIERR_LBARNG,			//
                    ASPIERR_INVFCDB,		//		
                    ASPIERR_NOLOGUN,		//
                    ASPIERR_INVFPL,			//
                    ASPIERR_PARNSUP,		//
                    ASPIERR_PARVINV,		//100
                    ASPIERR_NTHRPAR,		//
                    ASPIERR_WRTPROT,		//	
                    ASPIERR_NRDYRDY,		//
                    ASPIERR_POWRON,			//
                    ASPIERR_PARCHN,			//
                    ASPIERR_MPARCHN,		//
                    ASPIERR_LPARCHN,		//	
                    ASPIERR_NCPYDIS,		//
                    ASPIERR_CMDSEQ,			//
                    ASPIERR_CMDCLR,			//110
                    ASPIERR_INCPMED,		//
                    ASPIERR_CANTRDU,		//	
                    ASPIERR_CANTRDI,		//
                    ASPIERR_CLNCARD,		//
                    ASPIERR_MFRMCRP,		//
                    ASPIERR_TAPELEN,		//	
                    ASPIERR_RNDPAR,			//
                    ASPIERR_SAVPAR,			//
                    ASPIERR_NOTAPE,			//
                    ASPIERR_SEQPOS,			//120	
                    ASPIERR_POSBOM,			//
                    ASPIERR_POSEOM,			//	
                    ASPIERR_REPOS,			//	
                    ASPIERR_INVBITS,		//
                    ASPIERR_LUNSCFG,		//
                    ASPIERR_TRGOCHG,		//
                    ASPIERR_CHGUC,			//
                    ASPIERR_CHGOD,			//	
                    ASPIERR_CHGINQ,			//
                    ASPIERR_DGFAIL,			//130
                    ASPIERR_MSGERR,			//	
                    ASPIERR_INTTRGF,		//	
                    ASPIERR_SELRESF,		//
                    ASPIERR_SFTRSTF,		//
                    ASPIERR_INDEMSG,		//
                    ASPIERR_INVMSGE,		//
                    ASPIERR_CMDPHSE,		//	
                    ASPIERR_DATPHSE,		//
                    ASPIERR_LGUFSLF,		//
                    ASPIERR_OVRCMD,			//140
                    ASPIERR_WRTAPE,			//	
                    ASPIERR_WRTAPSE,		//
                    ASPIERR_POSETIM,		//
                    ASPIERR_ERSFAIL,		//
                    ASPIERR_CRDFAIL,		//	
                    ASPIERR_MDLFAIL,		//
                    ASPIERR_UNTAPF,			//
                    ASPIERR_MDRMPRV,		//	
                    ASPIERR_OPERREQ,		//
                    ASPIERR_OPERMRR,		//150
                    ASPIERR_OPERSWP,		//
                    ASPIERR_OPERSWE,		//
                    ASPIERR_LOGTRAP,		//
                    ASPIERR_THRCND,			//
                    ASPIERR_LGCNTMX,		//	
                    ASPIERR_LGLSCDE,		//
					ASPIERR_NOTATAPE,		//
					ASPIERR_NOTINSTALLED};	//158		

//
//Its VERY IMPOTANT to have byte-alignment from this point to the end of this header-file,
//since these definitions are used for direct-hardware-access.
//
#pragma pack(1)


typedef struct 
{                 /* common ccb for 6 byte commands */
  unsigned cmd : 8;
  unsigned flag0 : 1;
  unsigned flag1 : 1;
  unsigned flag2 : 1;
  unsigned flag3 : 1;
  unsigned flag4 : 1;
  unsigned lun : 3;				//logical unit number
  unsigned adr_1 : 8;
  unsigned adr_0 : 8;
  unsigned len : 8;
  unsigned control : 8;
}_ccb6;

typedef struct 
{                 /* common ccb for 6 byte commands */
  unsigned cmd : 8;
  unsigned flag0 : 1;
  unsigned flag1 : 1;
  unsigned flag2 : 1;
  unsigned flag3 : 1;
  unsigned flag4 : 1;
  unsigned lun : 3;				//logical unit number
  unsigned adr_1 : 8;
  unsigned adr_0 : 8;
  unsigned len : 8;
  unsigned control : 8;
  unsigned _reserved1 : 8;
  unsigned _reserved2 : 8;
  unsigned _reserved3 : 8;
  unsigned _reserved4 : 8;
}_ccb10;

typedef struct 
{                  /* used for the scsi inquiry command */
  unsigned cmd : 8;				//
  unsigned _reserved1 : 5;		//n/a
  unsigned lun : 3;				//logical unit number
  unsigned _reserved2 : 7;		//n/a
  unsigned evpd : 1;			//
  unsigned vpd : 8;				//
  unsigned len : 8;				//
  unsigned control : 8;			//	
}_inq;

typedef struct 
{                 /* used for the start/stop unit command */
  unsigned cmd : 8;				//	
  unsigned immed : 1;			//return immediatly ?
  unsigned _reserved1 : 4;		//n/a
  unsigned lun : 3;				//logical unit number
  unsigned _reserved2 : 8;		//n/a
  unsigned _reserved3 : 8;		//n/a
  unsigned start : 1;			//
  unsigned eject : 1;			//	
  unsigned _reserved4 : 6;		//n/a
  unsigned control : 8;			//
}_stp;

typedef struct 
{                 /* used for the allow medium removal command */
  unsigned cmd : 8;				//			
  unsigned _reserved1 : 5;		//n/a
  unsigned lun : 3;				//logical unit number
  unsigned _reserved2 : 8;		//n/a
  unsigned _reserved3 : 8;		//n/a
  unsigned prevent : 1;			//prevent medium removal (1) allow removal (0)
  unsigned _reserved4 : 7;		//n/a
  unsigned control : 8;			//
}_rem;

/*
                           Table 35 - COPY command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (18h)                        |
|-----+-----------------------------------------------------------------------|
| 1   | Logical unit number      |              Reserved             |  Pad   |
|-----+-----------------------------------------------------------------------|
| 2   | (MSB)                                                                 |
|-----+---                                                                 ---|
| 3   |                           Parameter list length                       |
|-----+---                                                                 ---|
| 4   |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct
{
	unsigned cmd : 8;				//0x18
	unsigned pad : 1;				//the pad bit  (-> cat-bit)
	//pad 1, cat 0: - fill destination .... thats ours !
	unsigned _reserved1 : 4;		//n/a
	unsigned lun : 3;				//logical unit number
	unsigned len_2 : 8;				//+ segment descriptor size
	unsigned len_1 : 8;				//  parameter header size
	unsigned len_0 : 8;				//list length=
	unsigned control : 8;			//
}_cpy;

/*
                         Table 343 - RESERVE command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (16h)                        |
|-----+-----------------------------------------------------------------------|
| 1   | Logical unit number      | 3rdPty | Third party device ID    | Element|
|-----+-----------------------------------------------------------------------|
| 2   |                           Reservation identification                  |
|-----+-----------------------------------------------------------------------|
| 3   | (MSB)                                                                 |
|-----+---                        Element list length                      ---|
| 4   |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct   
{
	unsigned cmd : 8;				//0x16
	unsigned element : 1;			//
	unsigned third_party_id : 3;	//
	unsigned third_party : 1;		//
	unsigned lun : 3;				//logical unit number
	unsigned res_id : 8;			//
	unsigned len_1 : 8;				//	
	unsigned len_0 : 8;				//
	unsigned control : 8;			//
}_rsv;


/*
                       Table 176 - LOAD UNLOAD command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (1Bh)                        |
|-----+-----------------------------------------------------------------------|
| 1   |   Logical unit number    |              Reserved             | Immed  |
|-----+-----------------------------------------------------------------------|
| 2   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 3   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 4   |                           Reserved         |   EOT  |  Reten |  Load  |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct   
{
  unsigned cmd : 8;				//0x1B
  unsigned immediate : 1;		//return immediatly ?
  unsigned _reserved1 : 4;		//n/a
  unsigned lun : 3;				//logical unit number
  unsigned _reserved2 : 8;		//n/a
  unsigned _reserved3 : 8;		//n/a
  unsigned load : 1;			//load=1 unload=0
  unsigned retention : 1;		//retension tape ?
  unsigned eot : 1;				//reposition to end of tape before unload ?
  unsigned _reserved4 : 5;		//n/a
  unsigned control : 8;			//
}_ld;

/*
                          Table 177 - LOCATE command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (2Bh)                        |
|-----+-----------------------------------------------------------------------|
| 1   |    Logical unit number   |      Reserved   |   BT   |   CP   | Immed  |
|-----+-----------------------------------------------------------------------|
| 2   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 3   | (MSB)                                                                 |
|-----+---                                                                 ---|
| 4   |                                                                       |
|-----+---                        Block address                            ---|
| 5   |                                                                       |
|-----+---                                                                 ---|
| 6   |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 7   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 8   |                           Partition                                   |
|-----+-----------------------------------------------------------------------|
| 9   |                           Control                                     |
+=============================================================================+
*/
typedef struct 
{
  unsigned cmd : 8;			//0x2B
  unsigned immediate : 1;	//return immediately
  unsigned cp : 1;			//use and update partition field ?
  unsigned bt : 1;			//SCSI- (0) or device-block (1)
  unsigned _reserved1 : 2;	//n/a
  unsigned lun : 3;			//logical unit number
  unsigned _reserved2 : 8;	//n/a
  unsigned blk_1 : 8;		//block adress
  unsigned blk_2 : 8;		//block adress
  unsigned blk_3 : 8;		//block adress
  unsigned blk_4 : 8;		//block adress
  unsigned _reserved3 : 8;	//n/a
  unsigned partition : 8;	//partition number
  unsigned control : 8;		//
}_loc;

/*
                     Table 192 - WRITE FILEMARKS command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (10h)                        |
|-----+-----------------------------------------------------------------------|
| 1   |   Logical unit number    |         Reserved         |  WSmk  | Immed  |
|-----+-----------------------------------------------------------------------|
| 2   | (MSB)                                                                 |
|-----+---                                                                 ---|
| 3   |                           Transfer length                             |
|-----+---                                                                 ---|
| 4   |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct 
{  
  unsigned cmd : 8;				//0x10
  unsigned immediate : 1;		//return immediatly ?
  unsigned wsmk : 1;			//write setmarks ?
  unsigned _reserved1 : 3;		//n/a
  unsigned lun : 3;				//logical unit number
  unsigned len_2 : 8;			//number of marks
  unsigned len_1 : 8;			//number of marks
  unsigned len_0 : 8;			//number of marks
  unsigned control : 8;			//
}_wrmk;


/*
                           Table 178 - READ command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (08h)                        |
|-----+-----------------------------------------------------------------------|
| 1   |   Logical unit number     |        Reserved         |  SILI  | Fixed  |
|-----+-----------------------------------------------------------------------|
| 2   | (MSB)                                                                 |
|-----+---                                                                 ---|
| 3   |                           Transfer length                             |
|-----+---                                                                 ---|
| 4   |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct   
{  
  unsigned cmd : 8;				//0x08
  unsigned fixed : 1;			//
  unsigned sili : 1;			//
  unsigned _reserved1 : 3;		//n/a
  unsigned lun : 3;				//logical unit number
  unsigned len_2 : 8;			//	
  unsigned len_1 : 8;			//
  unsigned len_0 : 8;			//
  unsigned control : 8;			//
}_rdwr;

/*
                          Table 188 - SPACE command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation  (11h)                            |
|-----+-----------------------------------------------------------------------|
| 1   |   Logical unit number    |     Reserved    |           Code           |
|-----+-----------------------------------------------------------------------|
| 2   | (MSB)                                                                 |
|-----+---                                                                 ---|
| 3   |                           Count                                       |
|-----+---                                                                 ---|
| 4   |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct 
{
  unsigned cmd : 8;						//0x11
  unsigned code : 3;					//blocks 		000 
										//filemarks 	001 
										//seq filemarks	010	
										//EOD 			011
										//setmarks		100
										//seq setmarks	101
  unsigned _reserved1 : 2;				//n/a
  unsigned lun : 3;						//logical unit number
  unsigned cnt2 : 8;					//
  unsigned cnt1 : 8;					//
  unsigned cnt0 : 8;					//	
  unsigned control : 8;					//
}_spc;

/*
                          Table 175 - ERASE command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (19h)                        |
|-----+-----------------------------------------------------------------------|
| 1   |   Logical unit number    |         Reserved          | Immed |  Long  |
|-----+-----------------------------------------------------------------------|
| 2   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 3   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 4   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct 	
{
	unsigned cmd : 8;				//0x19
	unsigned big : 1;				//shall all remaining medium in the 
									//current partition be erased beginning 
									//at the current logical position ?
	unsigned immediate : 1;			//return immediatly ?
	unsigned _reserved1 : 3;		//n/a
	unsigned lun : 3;				//logical unit number
	unsigned _reserved2 : 8;		//n/a
	unsigned _reserved3 : 8;		//n/a
	unsigned _reserved4 : 8;		//n/a
	unsigned control : 8;			//
}_ers;

/*
                       Table 54 - MODE SENSE(6) command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (1Ah)                        |
|-----+-----------------------------------------------------------------------|
| 1   | Logical unit number      |Reserved|   DBD  |         Reserved         |
|-----+-----------------------------------------------------------------------|
| 2   |       PC        |                   Page code                         |
|-----+-----------------------------------------------------------------------|
| 3   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 4   |                           Allocation length                           |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct 
{
	unsigned cmd : 8;				//0x1A
	unsigned _reserved1 : 3;		//n/a
	unsigned dbd : 1;				//disable block descriptor ?
	unsigned _reserved2 : 1;		//n/a
	unsigned lun : 3;				//logical unit number
	unsigned pagecode : 6;			//page code
	unsigned pc : 2;				//page control:	current values		00
									//				changable values	01
									//				default values		10
									//				saved values		11
	unsigned _reserved3 : 8;		//n/a
	unsigned len : 8;				//allocation length
	unsigned control : 8;			//
}_mdsn;


/*
                      Table 52 - MODE SELECT(6) command
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Operation code (15h)                        |
|-----+-----------------------------------------------------------------------|
| 1   | Logical unit number      |   PF   |         Reserved         |  SP    |
|-----+-----------------------------------------------------------------------|
| 2   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 3   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 4   |                           Parameter list length                       |
|-----+-----------------------------------------------------------------------|
| 5   |                           Control                                     |
+=============================================================================+
*/
typedef struct 
{
	unsigned cmd : 8;				//0x15
	unsigned sp : 1;				//save page ?
	unsigned _reserved1 : 3;		//n/a
	unsigned pf : 1;				//SCSI1 or standard ?
	unsigned lun : 3;				//logical unit number
	unsigned _reserved2 : 8;		//n/a
	unsigned _reserved3 : 8;		//n/a
	unsigned len : 8;				//allocation length
	unsigned control : 8;			//
}_mdsl;



typedef union  
{
  _ccb6 c6;				//Generic 6Byte Command
  _ers ers;				//ERASE
  _inq inq;				//HA INQUIRY
  _cpy cpy;				//COPY
  _rsv rsv;				//RESERVE
  _stp stp;				//START/STOP
  _rem rem;				//LOCK/UNLOCK
  _ld ld;				//LOAD/UNLOAD
  _rdwr rdwr;			//READ/WRITE
  _wrmk wrmk;			//WRITE FILEMARK
  _mdsn mdsn;			//MODE SENSE	
  _mdsl mdsl;			//MODE SELECT
  _spc spc;				//SPACE
  _ccb10 c10;			//Generic 10Byte Command
}_ccb;

/*
This is the most important structure; all commands are wrapped inside these
parameters.
*/
typedef struct
{
	BYTE	SRB_Cmd;				//ASPI command code = SC_EXEC_SCSI_CMD
	BYTE	SRB_Status;				//ASPI command status byte
	BYTE	SRB_HaId;				//ASPI host adapter number
	BYTE	SRB_Flags;				//ASPI request flags
	DWORD	SRB_Hdr_Rsvd;			//Reserved
	BYTE	SRB_Target;				//Target's SCSI ID
	BYTE	SRB_Lun;				//Target's LUN number
	WORD	SRB_Rsvd1;				//Reserved for Alignment
	DWORD	SRB_BufLen;				//Data Allocation Length
	BYTE	*SRB_BufPointer;		//Data Buffer Pointer
	BYTE	SRB_SenseLen;			//Sense Allocation Length
	BYTE	SRB_CDBLen;				//CDB Length
	BYTE	SRB_HaStat;				//Host Adapter Status
	BYTE	SRB_TargStat;			//Target Status
	HANDLE	SRB_PostProc;			//Post routine
	void	*SRB_Rsvd2;				//Reserved
	BYTE	SRB_Rsvd3[16];			//Reserved for alignment
	_ccb	ccb;					//SCSI Command Descriptor Block
	BYTE	SRB_Rsvd4[4];			//Reserved for alignment
	BYTE	SenseArea[SENSE_LEN+2]; //Request Sense buffer
} SRB_MyExecSCSICmd, *PSRB_MyExecSCSICmd;









/*
                    Table 200 - Device configuration page
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+========+========+=====================================================|
| 0   |   PS   |Reserved|         Page code (10h)                             |
|-----+-----------------------------------------------------------------------|
| 1   |                           Page length (0Eh)                           |
|-----+-----------------------------------------------------------------------|
| 2   |Reserved|  CAP   |  CAF   |                Active format               |
|-----+-----------------------------------------------------------------------|
| 3   |                           Active partition                            |
|-----+-----------------------------------------------------------------------|
| 4   |                           Write buffer full ratio                     |
|-----+-----------------------------------------------------------------------|
| 5   |                           Read buffer empty ratio                     |
|-----+-----------------------------------------------------------------------|
| 6   | (MSB)                                                                 |
|-----+---                        Write delay time                         ---|
| 7   |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 8   |  DBR   |  BIS   |  RSmk  |  AVC   |      SOCF       |   RBO  |  REW   |
|-----+-----------------------------------------------------------------------|
| 9   |                           Gap size                                    |
|-----+-----------------------------------------------------------------------|
| 10  |      EOD defined         |  EEG   |  SEW   |        Reserved          |
|-----+-----------------------------------------------------------------------|
| 11  | (MSB)                                                                 |
|-----+---                                                                 ---|
| 12  |                           Buffer size at early warning                |
|-----+---                                                                 ---|
| 13  |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 14  |                           Select data compression algorithm           |
|-----+-----------------------------------------------------------------------|
| 15  |                           Reserved                                    |
+=============================================================================+
*/
typedef struct
{
	unsigned pagecode : 6;		//0x10
	unsigned _reserved1 : 1;	//n/a	
	unsigned ps : 1;			//
	unsigned len : 8;			//0x0E (n-2)
	unsigned format : 5;		//active format
	unsigned caf : 1;			//
	unsigned cap : 1;			//
	unsigned _reserved2 : 1;	//n/a
	unsigned partition : 8;		//active partition
	unsigned wrratio : 8;		//write buffer full ratio
	unsigned rdratio : 8;		//read buffer empty ratio
	unsigned delay1 : 8;		//write delay time (MSB)
	unsigned delay2 : 8;		//write delay time (LSB)
	unsigned rew : 1;			//
	unsigned rbo : 1;			//
	unsigned socf : 2;			//
	unsigned avc : 1;			//
	unsigned rsmk : 1;			//read setmarks
	unsigned bis : 1;			//
	unsigned dbr : 1;			//
	unsigned gap : 8;			//gap size
	unsigned _reserved3 : 3;	//n/a
	unsigned sew : 1;			//
	unsigned eeg : 1;			//
	unsigned eod : 3;			//
	unsigned size1 : 8;			//Buffer size at early warning (MSB)
	unsigned size2 : 8;			//Buffer size at early warning (...)
	unsigned size3 : 8;			//Buffer size at early warning (LSB)
	unsigned comp : 8;			//data compression algorithm
	unsigned _reserved4 : 8;	//n/a	
}_MPG_devconf;

/*
                    Table 202 - Medium partition page(1)
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+========+========+=====================================================|
| 0   |   PS   |Reserved|         Page code (11h)                             |
|-----+-----------------------------------------------------------------------|
| 1   |                           Page length                                 |
|-----+-----------------------------------------------------------------------|
| 2   |                           Maximum additional partitions               |
|-----+-----------------------------------------------------------------------|
| 3   |                           Additional partitions defined               |
|-----+-----------------------------------------------------------------------|
| 4   |  FDP   |  SDP   |  IDP   |       PSUM      |       Reserved           |
|-----+-----------------------------------------------------------------------|
| 5   |                           Medium format recognition                   |
|-----+-----------------------------------------------------------------------|
| 6   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 7   |                           Reserved                                    |
|=====+=======================================================================|
|     |                   Partition size descriptor(s)                        |
|=====+=======================================================================|
| 0   | (MSB)                                                                 |
|-----+---                        Partition size                           ---|
| 1   |                                                                 (LSB) |
+=============================================================================+
*/
typedef struct
{
	unsigned pagecode : 6;		//0x11
	unsigned _reserved1 : 1;	//n/a	
	unsigned ps : 1;			//
	unsigned len : 8;			//
	unsigned maxadd : 8;		//
	unsigned adddef : 8;		//
	unsigned _reserved2 : 3;	//n/a
	unsigned psum : 2;			//
	unsigned idp : 1;			//
	unsigned sdp : 1;			//
	unsigned fdp : 1;			//
	unsigned medrec : 8;		//
}_MPG_partition;
	/*
	unsigned _reserved3 : 8;	//n/a
	unsigned _reserved4 : 8;	//n/a	
	unsigned size1 : 8;			//
	unsigned size2 : 8;			//
}_MPG_partition1;
*/


//Data Compression Page
typedef struct
{
	unsigned pagecode : 6;		//0x0F
	unsigned _reserved1 : 1;	//n/a	
	unsigned ps : 1;			//
	unsigned len : 8;			//
	unsigned _reserved2 : 6;	//n/a
	unsigned dcc : 1;			//data compression ????
	unsigned dce : 1;			//data compression enable
	unsigned _reserved3 : 5;	//n/a
	unsigned red : 2;			//
	unsigned dde : 1;			//data decompression enable
	unsigned comp_1 : 8;		//compression algorithm
	unsigned comp_2 : 8;		//
	unsigned comp_3 : 8;		//
	unsigned comp_4 : 8;		//
	unsigned decomp_1 : 8;		//decompression algorithm
	unsigned decomp_2 : 8;		//
	unsigned decomp_3 : 8;		//
	unsigned decomp_4 : 8;		//
	unsigned _reserved4 : 8;	//n/a
	unsigned _reserved5 : 8;	//n/a	
	unsigned _reserved6 : 8;	//n/a
	unsigned _reserved7 : 8;	//n/a
}_MPG_compression;


/*
                     Table 91 - Mode parameter header(6)
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Mode data length                            |
|-----+-----------------------------------------------------------------------|
| 1   |                           Medium type                                 |
|-----+-----------------------------------------------------------------------|
| 2   |                           Device-specific parameter                   |
|-----+-----------------------------------------------------------------------|
| 3   |                           Block descriptor length                     |
+=============================================================================+
*/
typedef struct
{
	unsigned modesize : 8;		//
	unsigned medium : 8;		//
	unsigned speed : 4;			//
	unsigned buff : 3;			//buffered mode 
	unsigned wp : 1;			//write protected ?
	unsigned bdsize : 8;		//block descriptor length
}ParameterHeader;

/*
                  Table 93 - Mode parameter block descriptor
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+=======================================================================|
| 0   |                           Density code                                |
|-----+-----------------------------------------------------------------------|
| 1   | (MSB)                                                                 |
|-----+---                                                                 ---|
| 2   |                           Number of blocks                            |
|-----+---                                                                 ---|
| 3   |                                                                 (LSB) |
|-----+-----------------------------------------------------------------------|
| 4   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 5   | (MSB)                                                                 |
|-----+---                                                                 ---|
| 6   |                           Block length                                |
|-----+---                                                                 ---|
| 7   |                                                                 (LSB) |
+=============================================================================+
*/
typedef struct
{
	unsigned density : 8;		//
	unsigned blocks1 : 8;		//
	unsigned blocks2 : 8;		//
	unsigned blocks3 : 8;		//
	unsigned _reserved1 : 8;	//n/a
	unsigned size1 : 8;			//
	unsigned size2 : 8;			//
	unsigned size3 : 8;			//
}BlockDescriptor;

//complete Device Configuration Mode-Page
typedef struct
{
	ParameterHeader		head;
	BlockDescriptor		bd;
	_MPG_devconf		dev;
}MPG_devconf;

//complete Partition1 Mode-Page (e.g.Sony)
typedef struct
{
	ParameterHeader		head;
	BlockDescriptor		bd;
	_MPG_partition		par;
}MPG_partition;

//complete Partition1 Mode-Page for most DAT-Streamers
typedef struct
{
	ParameterHeader		head;
	_MPG_partition		par;
}MPG_partition_small;

//complete Compression Mode-Page
typedef struct
{
	ParameterHeader		head;
	BlockDescriptor		bd;
	_MPG_compression	com;
}MPG_compression;

/*
                        Table 36 - COPY parameter list
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+============================================+==========================|
| 0   |         COPY function code                 |         Priority         |
|-----+-----------------------------------------------------------------------|
| 1   |                           Vendor-specific                             |
|-----+-----------------------------------------------------------------------|
| 2   |                           Reserved                                    |
|-----+-----------------------------------------------------------------------|
| 3   |                           Reserved                                    |
|=====+=======================================================================|
|     |                         Segment descriptor(s)                         |
|=====+=======================================================================|
| 0   |                           Segment descriptor 0                        |
|- - -+---                                                                 ---|
| n   |                     (See specific table for length.)                  |
|-----+-----------------------------------------------------------------------|
|     |                                 .                                     |
|     |                                 .                                     |
|-----+-----------------------------------------------------------------------|
| 0   |                           Segment descriptor x                        |
|- - -+---                                                                 ---|
| n   |                     (See specific table for length.)                  |
+=============================================================================+
*/
typedef struct
{
	unsigned priority : 3;		//01 00
	unsigned code : 5;			//function code 0x04 for image copy 
	unsigned vendor : 8;		//???
	unsigned _reserved1 : 8;	//n/a
	unsigned _reserved2 : 8;	//n/a
	//segment descriptors
	//....
}CPY_para_head;

/*
           Table 41 - Segment descriptor for COPY function code 04h
+=====-========-========-========-========-========-========-========-========+
|  Bit|   7    |   6    |   5    |   4    |   3    |   2    |   1    |   0    |
|Byte |        |        |        |        |        |        |        |        |
|=====+==========================+=================+==========================|
| 0   | Source address           |   Reserved      | Source LUN               |
|-----+--------------------------+-----------------+--------------------------|
| 1   | Destination address      |   Reserved      | Destination LUN          |
|-----+-----------------------------------------------------------------------|
| 2   |                              Count                                    |
|-----+-----------------------------------------------------------------------|
| 3   |                                                                       |
|- - -+---                           Reserved                              ---|
| 7   |                                                                       |
|-----+-----------------------------------------------------------------------|
| 8   |                                                                       |
|- - -+---                           Vendor-specific                       ---|
| 11  |                                                                       |
+=============================================================================+
*/
typedef struct
{
	unsigned source_lun : 3;	//source lun
	unsigned _reserved1 : 2;	//n/a
	unsigned source_id : 3;		//source id
	unsigned dest_lun : 3;		//destination lun
	unsigned _reserved2 : 2;	//n/a
	unsigned dest_id : 3;		//destination id
	unsigned count : 8;			//count (number of setmarks or filemarks to copy)
	unsigned _reserved3 : 8;	//n/a
	unsigned _reserved4 : 8;	//n/a
	unsigned _reserved5 : 8;	//n/a
	unsigned _reserved6 : 8;	//n/a
	unsigned _reserved7 : 8;	//n/a
	unsigned vendor1 : 8;		//???
	unsigned vendor2 : 8;		//???
	unsigned vendor3 : 8;		//???
	unsigned vendor4 : 8;		//???
}CPY_segment_desc;