// ASPIsnoopDlg.h : header file
//
#include "AspiDriver.h"
/////////////////////////////////////////////////////////////////////////////
// CASPIsnoopDlg dialog
class CASPIsnoopDlg : public CDialog
{
// Construction
public:
	CASPIsnoopDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CASPIsnoopDlg)
	enum { IDD = IDD_ASPISNOOP_DIALOG };
	CButton	m_btnCopy;
	CComboBox	m_cbMode;
	CComboBox	m_cbPage;
	CButton	m_btnCompression;
	CButton	m_btnSeekEOD;
	CButton	m_btnWriteMark;
	CButton	m_btnWrite;
	CButton	m_btnSpace;
	CButton	m_btnSnoop;
	CButton	m_btnRezero;
	CButton	m_btnReset;
	CButton	m_btnReadLimits;
	CButton	m_btnRead;
	CButton	m_btnGetPos;
	CButton	m_btnGetParas;
	CButton	m_btnEject;
	CListBox	m_ListBox;
	BOOL	m_bFileSeek;
	int		m_nOffset;
	BOOL	m_bSetMark;
	BOOL	m_bCompression;
	DWORD	m_dwBlkSize;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CASPIsnoopDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CFont m_fontNormal;
	CFont m_fontBold;
	void DisplayDeviceMP (LPVOID pBuffer);
	void DisplayPartitionMP (LPVOID pBuffer);
	void DisplayCompressionMP (LPVOID pBuffer);

	BOOL InitTapeParameters (void);
	void Error (DWORD code);
	void enableButtons (BOOL stat);
	void SenseDone (void);

	void SpaceDone (void);
	void WriteDone (void);
	void WriteFileMarkDone (void);
	void ReadLimitsDone (void);
	void ResetDone (void);
	void EjectDone (void);
	void SnoopDone (void);
	void RezeroDone (void);

	BYTE		m_cTapeHost;
	BYTE		m_cTapeID;
	BYTE		m_cTapeLun;
	DWORD		m_nIOSize;
	HGLOBAL		m_hIOBuffer;
	char		*m_pIOBuffer;
	HICON		m_hIcon;
	DWORD		m_nCount;
	CASPIDriver *m_pASPI;

	// Generated message map functions
	//{{AFX_MSG(CASPIsnoopDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSnoop();
	afx_msg void OnDestroy();
	afx_msg void OnReset();
	afx_msg void OnEject();
	afx_msg void OnRezero();
	afx_msg void OnReadlimits();
	afx_msg void OnRead();
	afx_msg void OnWritemark();
	afx_msg void OnWrite();
	afx_msg void OnGetpos();
	afx_msg void OnSpace();
	afx_msg void OnGetParameters();
	afx_msg void OnClear();
	afx_msg void OnCompression();
	afx_msg void OnSeekeod();
	afx_msg void OnConfigure();
	afx_msg void OnUpdateBlksize();
	afx_msg void OnCopy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
